VERSION 5.00
Begin VB.UserControl RotLabel 
   BackStyle       =   0  'Transparent
   ClientHeight    =   255
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1965
   HitBehavior     =   0  'None
   MaskColor       =   &H00000000&
   ScaleHeight     =   17
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   131
   ToolboxBitmap   =   "RotLabel.ctx":0000
   Begin VB.PictureBox picMask 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H000000FF&
      Height          =   255
      Left            =   0
      ScaleHeight     =   17
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   17
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   255
   End
End
Attribute VB_Name = "RotLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Set at design time:
'   UserControl.MaskColor = Black
'   UserControl.BackStyle = Transparent
'   picMask.Visible = False
'   picMask.BackColor = Black
'   picMask.FireColor = Red
'   picMask.AutoRedraw = True

Public Event Click()

' Default property values.
Private Const m_def_Angle = 0
Private Const m_def_Caption = "RotLabel"

' Property variables.
Private m_Angle As Single
Private m_Caption As String
Private m_Font As Font

Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal I As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

' Draw the text at the correct angle.
Private Sub DrawValue(ByVal txt As String)
Const FW_BOLD = 700
Const FW_NORMAL = 400

Dim wgt As Long
Dim X As Single
Dim Y As Single

    ' Clear the control.
    Cls

    ' See whether the text should be bold.
    If m_Font.Bold Then
        wgt = FW_BOLD
    Else
        wgt = FW_NORMAL
    End If

    ' Estimate where the text should begin. My book
    ' "Visual Basic Graphics Programming" shows how to
    ' calculate this exactly but it's work so we won't
    ' do it here. For more information, go to:
    '
    '       http://www.vb-helper.com/vbgp.htm
    '
    ' This only works for 0 <= Angle <= 90.
    X = 0
    Y = ScaleY(Height, vbTwips, ScaleMode) - _
        ScaleY(m_Font.Size, vbPoints, ScaleMode)

    ' Draw the text.
    DrawRotatedText txt, X, Y, m_Font.Name, _
        ScaleX(m_Font.Size, vbPoints, vbPixels), _
        wgt, Angle * 10, _
        m_Font.Italic, m_Font.Underline, _
        m_Font.Strikethrough
End Sub

' Set the label's caption.
Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PropertyChanged "Caption"

    DrawValue m_Caption
End Property
' Return the label's caption.
Public Property Get Caption() As String
    Caption = m_Caption
End Property

' Draw the text.
Private Sub DrawRotatedText(ByVal txt As String, _
    ByVal X As Single, ByVal Y As Single, _
    ByVal font_name As String, ByVal Size As Long, _
    ByVal weight As Long, ByVal escapement As Long, _
    ByVal use_italic As Boolean, ByVal use_underline As Boolean, _
    ByVal use_strikethrough As Boolean)

Const CLIP_LH_ANGLES = 16   ' Needed for tilted fonts.
Const PI = 3.14159625
Const PI_180 = PI / 180#

Dim newfont As Long
Dim oldfont As Long
Dim hRgn As Long

    picMask.Move 0, 0, ScaleWidth, ScaleHeight
    picMask.Font = m_Font
    picMask.Cls

    newfont = CreateFont(Size, 0, _
        escapement, escapement, weight, _
        use_italic, use_underline, _
        use_strikethrough, 0, 0, _
        CLIP_LH_ANGLES, 0, 0, font_name)

    ' Select the new font.
    oldfont = SelectObject(picMask.hdc, newfont)

    ' Draw the text on picMask.
    picMask.CurrentX = X
    picMask.CurrentY = Y
    picMask.Print txt

    ' Restore the original font.
    newfont = SelectObject(picMask.hdc, oldfont)
    
    ' Free font resources (important!)
    DeleteObject newfont

    ' Make the control use picMask as a mask picture.
    UserControl.MaskPicture = picMask.Image
End Sub
' Set the text color.
Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor = New_ForeColor
    UserControl.BackColor = UserControl.ForeColor
    PropertyChanged "ForeColor"

    DrawValue m_Caption
End Property
' Return the text color.
Public Property Get ForeColor() As OLE_COLOR
    ForeColor = UserControl.ForeColor
End Property

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub
' Initialize properties.
Private Sub UserControl_InitProperties()
    m_Angle = m_def_Angle
    Set m_Font = Ambient.Font
    m_Caption = m_def_Caption
End Sub

' Load properties.
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_Angle = PropBag.ReadProperty("Angle", m_def_Angle)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    Set m_Font = PropBag.ReadProperty("Font", Ambient.Font)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", Ambient.ForeColor)
    UserControl.BackColor = UserControl.ForeColor
End Sub

Private Sub UserControl_Resize()
    DrawValue m_Caption
End Sub

Private Sub UserControl_Show()
    DrawValue m_Caption
End Sub


' Save properties.
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Angle", m_Angle, m_def_Angle
    PropBag.WriteProperty "Caption", m_Caption, m_def_Caption
    PropBag.WriteProperty "Font", m_Font, Ambient.Font
    PropBag.WriteProperty "ForeColor", UserControl.ForeColor, Ambient.ForeColor
End Sub



' Return the text's angle.
Public Property Get Angle() As Single
    Angle = m_Angle
End Property

' Set the text's rotation angle.
Public Property Let Angle(ByVal New_Angle As Single)
    m_Angle = New_Angle
    PropertyChanged "Angle"

    DrawValue m_Caption
End Property

' Return the control's Font object.
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = m_Font
End Property

' Set the control's Font.
Public Property Set Font(ByVal new_font As Font)
    Set m_Font = new_font
    PropertyChanged "Font"

    DrawValue m_Caption
End Property
